#![allow(dead_code)]

mod ast;
mod lexer;
mod parser;
mod tokens;

use crate::lexer::Lexer;
use crate::parser::Parser;

fn main() {
    // println!("tokens = [");
    // let text = "** 3.14 \"foo\" false true ( ) + += /* 1 /* 2 */ 3 */  // 4 \n 5";
    // let lexer = Lexer::new(text);
    // lexer.for_each(|token| {
    //     println!(
    //         "    {:?} = `{}`,",
    //         token.token_type,
    //         &text[token.pos.index..token.pos.index + token.length]
    //     );
    // });
    // println!("]");

    let text2 = "[1, 1..=2, ...a]";
    let lexer2 = Lexer::new(text2);
    println!("tokens = [");
    lexer2.for_each(|token| {
        println!(
            "    ({:?}, `{}`, [{}], {}, {}:{}),",
            token.token_type,
            &text2[token.pos.index..token.pos.index + token.length],
            token.pos.index,
            token.length,
            token.pos.line,
            token.pos.col,
        );
    });
    println!("]");
    let mut parser = Parser::new(text2, Lexer::new(text2));
    let expr = parser.parse_expr();
    println!("ast = {:#?}", expr);
}
